# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####

bl_info = {
    "name": "Object Linker",
    "author": "rubberduck",
    "version": (0, 1),
    "blender": (2, 69, 0),
    "location": "--",
    "description": "--",
    "warning": "",
#    "wiki_url": "--"
#                "--",
    "category": "Object"}



if "bpy" in locals():
    import imp
    imp.reload(object_linker)
else:
	from . import object_linker


import os

default_filepath = os.path.dirname(__file__)

from bpy.props import *
import bpy
import bgl
import blf





class Update_List(bpy.types.Operator):
	bl_idname = "ops.updatelist"
	bl_label = "update list"
 
	def execute(self, context):
		
		object_linker.dir_path_update(self, context)

			
		return{'FINISHED'} 

class LinkAppendObject(bpy.types.Operator):
	bl_idname = "ops.linkappend"
	bl_label = "Link/ Append Object"
 
	def execute(self, context):
		object_link = object_linker.get_object_value(context.scene.game_object, "OBJECT")[0]
		
		if object_link != "no_value_found":
			filename = "objects"
			file_found = False
			blend_file = object_linker.get_object_value(context.scene.game_object, "FILE")[0]
			if blend_file != "no_value_found":
				filename = blend_file
			ob = object_linker.get_object_value(context.scene.game_object, "OBJECT")[0]
			folder = object_linker.get_object_value(context.scene.game_object, "FOLDER")[0]
			blend_dir = context.scene.choose_path + folder + "/"
			print (blend_dir)
			for root, directo, files in os.walk(blend_dir):
				if filename + ".blend" in files:
					file_found = True
					break
			if file_found == False:
				print ("missing file")
			else:
			


				blend_path = filename + ".blend/Object/"
				try:
					if context.scene.checkbox_link == True:


						bpy.ops.wm.link_append(filepath = "//" + blend_path + ob, filename = ob, directory = blend_dir + blend_path, active_layer = True)
						bpy.ops.object.make_local(type='SELECT_OBJECT')	

					else:

						bpy.ops.wm.link_append(filepath = "//" + blend_path + ob, filename = ob, directory = blend_dir + blend_path, active_layer = True)
						bpy.context.scene.objects.active = bpy.context.selected_objects[0]
						new = bpy.context.scene.objects.active
						print (bpy.context.selected_objects) 
						new.data = new.data.copy() 
						bpy.ops.object.make_local(type='SELECT_OBDATA')
				
					bpy.ops.view3d.snap_selected_to_cursor(use_offset=True)
					bpy.context.scene.objects.active = bpy.context.selected_objects[0]
				except:
					print ("error: no object found")
				

			
		return{'FINISHED'}

class ObjectPreview(bpy.types.Panel):
	bl_label = "ObjectLinker_prev"   
	bl_space_type = 'PROPERTIES'
	bl_region_type = 'WINDOW'
	bl_context = "object"

	def draw(self, context):

		layout = self.layout
		scn = context.scene
		row = layout.row()
		if bpy.context.mode == "OBJECT" and context.scene.game_object != "" and "IMAGE" not in object_linker.hide_value_list:

			try:

				row.template_preview(object_linker.ui_tex, show_buttons=False)
			except:
				print ("error")
		if "IMAGE" in object_linker.hide_value_list:
			row.label("image preview disabled")

class ObjectPlacerPanel(bpy.types.Panel):
	bl_label = "ObjectLinker"
	bl_space_type = 'VIEW_3D'
	bl_region_type = 'TOOLS'
	bl_context = "objectmode"




	def draw(self, context):
		layout = self.layout
		scn = context.scene
		row = layout.row()
		object_linker.make_list(context.scene.choose_path)

		
		row2 = layout.row()
		
		col = layout.column()
		for values in object_linker.hide_value_list:
			print (values)

		
		col.operator("ops.updatelist")
		col.prop(context.scene, 'choose_path')
		col.prop_search(context.scene, "game_object", context.scene, "coll", text = "Object")
		col.prop(context.scene, 'sel_category')

		if context.scene.game_object != "":
			infobox = col.box()
			selected = context.scene.game_object
			if selected == "":
				selected = "none"
			

			categories = object_linker.get_object_value(context.scene.game_object, "CATEGORY")
			verts = object_linker.get_object_value(context.scene.game_object, "VERTS")[0]
			faces = object_linker.get_object_value(context.scene.game_object, "FACES")[0]
			edges = object_linker.get_object_value(context.scene.game_object, "EDGES")[0]
			verts_mod = object_linker.get_object_value(context.scene.game_object, "VERTS_MOD")[0]
			faces_mod = object_linker.get_object_value(context.scene.game_object, "FACES_MOD")[0]
			edges_mod = object_linker.get_object_value(context.scene.game_object, "EDGES_MOD")[0]
			object_file = object_linker.get_object_value(context.scene.game_object, "FILE")[0]
			license = object_linker.get_object_value(context.scene.game_object, "LICENSE")[0]
			artist = object_linker.get_object_value(context.scene.game_object, "ARTIST")[0]
			warnings = object_linker.get_object_value(context.scene.game_object, "WARNING")
			for cat in categories:
				if cat in object_linker.hide_list:
					categories.remove(cat)
			if categories == []:
				categories.append("none")
			categories = ", ".join(categories)
			if categories == "no_value_found":
				categories = "no categories found"
				

			if  "CATEGORY" not in object_linker.hide_value_list:
				infobox.label("Categories: " + categories)

			if  "SELECTED" not in object_linker.hide_value_list:
				infobox.label("Selected: " + selected)
			if verts != "no_value_found" and faces != "no_value_found" and edges != "no_value_found" and "VERTS" not in object_linker.hide_value_list and "EDGES" not in object_linker.hide_value_list and "FACES" not in object_linker.hide_value_list:
				infobox.label("Verts/Faces/Edges: " + verts + ", " + faces + ", " + edges)
			else:
				if verts != "no_value_found" and "VERTS" not in object_linker.hide_value_list:
					infobox.label("Verts: " + verts)
				if faces != "no_value_found" and "FACES" not in object_linker.hide_value_list:
					infobox.label("Faces: " + faces)
				if edges != "no_value_found" and "EDGES" not in object_linker.hide_value_list:
					infobox.label("Edges: " + edges)

			if verts_mod != "no_value_found" and faces_mod != "no_value_found" and edges_mod != "no_value_found" and "VERTS_MOD" not in object_linker.hide_value_list and "FACES_MOD" not in object_linker.hide_value_list and "EDGES_MOD" not in object_linker.hide_value_list:
				infobox.label("Verts/Faces/Edges(with modifiers): " + verts_mod + ", " + faces_mod + ", " + edges_mod)
			else:
				if verts_mod != "no_value_found" and "VERTS_MOD" not in object_linker.hide_value_list:
					infobox.label("Verts(with modifiers): " + verts_mod)
				if faces_mod != "no_value_found" and "FACES_MOD" not in object_linker.hide_value_list:
					infobox.label("Faces(with modifiers): " + faces_mod)
				if edges_mod != "no_value_found" and "EDGES_MOD" not in object_linker.hide_value_list:
					infobox.label("Edges(with modifiers): " + edges_mod)

			if object_file == "no_value_found":
				object_file = "objects"
			if  "FILE" not in object_linker.hide_value_list:
				infobox.label("FILE: " + object_file)

			if license != "no_value_found" and "LICENSE" not in object_linker.hide_value_list:
				infobox.label("License: " + license)

			if artist != "no_value_found"  and "ARTIST" not in object_linker.hide_value_list:
				infobox.label("Artist: " + artist)

			if warnings[0] != "no_value_found" and "WARNING" not in object_linker.hide_value_list:
				for warning in warnings:
					infobox.label("Warnings: " + warning)




			

		

		col.prop(context.scene, "checkbox_link")
		col.operator("ops.linkappend")




def register():

	bpy.utils.register_module(__name__)

	bpy.types.Scene.coll = bpy.props.CollectionProperty(
	type=bpy.types.PropertyGroup
	)
	


	bpy.types.Scene.choose_path = bpy.props.StringProperty(update = object_linker.dir_path_update, name="file path",
	
	attr="custompath",# this a variable that will set or get from the scene
	maxlen= 1024,
	subtype='DIR_PATH',
	default= default_filepath + "/"
	)
	bpy.types.Scene.sel_category = bpy.props.EnumProperty(update = object_linker.category_choose, name = "Category", items = 	object_linker.list_populate)

	bpy.types.Scene.game_object = bpy.props.StringProperty(update = object_linker.object_choose)
	bpy.types.Scene.select_category = bpy.props.StringProperty()
	bpy.types.Scene.checkbox_link = bpy.props.BoolProperty(name = "Link from Scene", default = True)

	bpy.app.handlers.load_post.append(object_linker.new_file_handler) 

	
	



def unregister():
	bpy.utils.unregister_module(__name__)


	del bpy.types.Scene.coll
	del bpy.types.Scene.choose_path
	del bpy.types.Scene.game_object
	del bpy.types.Scene.select_category
	del bpy.types.Scene.sel_category
	del bpy.types.Scene.checkbox_link
	bpy.app.handlers.load_post.remove(object_linker.new_file_handler)

	
	


if __name__ == "__main__":
	register()


