# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####


import bpy
import os
import bgl
import blf

from bpy.app.handlers import persistent

category_list = []
hide_list = []
hide_value_list = []
disabled_sets = []
add_value_list = []



def make_list(path):
	dir = ""
	open_file = "none"
	new_name = "none"
	new_value = "none"
	global global_object_list
	global global_object_values
	global_object_list = []
	disable_list = []
	disabled_objects = []
	ending = "jpg"
	ending2 = "jpg"

	global_object_values = []
	

	absolute_path = os.path.realpath(bpy.path.abspath(path))
	for root, directo, files in os.walk(absolute_path):
		dir = directo
		break

	for file in os.listdir(absolute_path):
		if file.endswith("settings.txt"):
			f = open(absolute_path + "/" + file, 'r')
			for line in f:
				if line.find("disable_category: ")== 0:
					disable_value = "CATEGORY: " + line.rstrip('\n').replace("disable_category: ", "")
					if disable_value not in disable_list:
						disable_list.append(disable_value)

				if line.find("hide_category: ")== 0:
					hide_value = line.rstrip('\n').replace("hide_category: ", "")
					if hide_value not in hide_list:
						hide_list.append(hide_value)

				if line.find("hide_value: ")== 0:
					hide_value = line.rstrip('\n').replace("hide_value: ", "")
					if hide_value not in hide_value_list:
						hide_value_list.append(hide_value)

				if line.find("disable_set: ")== 0:
					disabled_set = line.rstrip('\n').replace("disable_set: ", "")
					if disabled_set not in disabled_sets:
						disabled_sets.append(disabled_set)

				if line.find("ending: ")== 0:
					ending = line.rstrip('\n').replace("ending: ", "")
				ending2 = ending

			f.close()

	for folder in dir:

		 
		new_directory = absolute_path + "/" + folder

		


		for file in os.listdir(new_directory):
			if file.endswith("objects.txt"):
				open_file = "objects.txt"


		if  open_file != "none":
			f = open(new_directory + "/" + open_file, 'r')
			open_file = "none"
			file_disabled = False
			end_values = False
			new_name = "none"
			add_value_list.clear()
			ending = ending2

			for line in f:

				if line.find("disable set") == 0 or folder in disabled_sets:
					file_disabled = True


				if line.find("end values")>= 0:
					end_values = True

				
				if line.find("set_name: ")== 0:
					new_name = line.rstrip('\n').replace("set_name: ", "")
					set_name = new_name
				

				if line.find("ADD: ")== 0:
					new_value = line.rstrip('\n').replace("ADD: ", "")
					add_value_list.append(new_value)

				if line.find("ending: ")== 0: 
					ending = line.rstrip('\n').replace("ending: ", "")



				if len(line) > 3 and file_disabled == False and end_values == True and line.find("end values") < 0 and line.find("#") != 0: 
					new_line = line.rstrip('\n').replace(", ", ",")
				
					list_objects = new_line.split(",")
					
					for values in list_objects:
						if values.find("#")== 0:
							list_objects.remove(values)
					if line.find("#") != 0:
						
							
						global_object_name = folder + "_" + list_objects[0]
						name = list_objects[0]
						if new_name != "none":
							global_object_name = new_name + "_" + list_objects[0]
						list_objects[0] = global_object_name
						list_objects.append("FOLDER: " + folder)

						for values in add_value_list:
							if values not in list_objects:
								list_objects.append(values)

						
						
						object_value_found = False
						image_value_found = False
						for value in disable_list:
							if value in list_objects:
								disabled_objects.append(list_objects[0])


						for ob_value in list_objects:
							
							if "CATEGORY" in ob_value and list_objects[0] not in disabled_objects:
								category = ob_value.replace("CATEGORY: ", "")
								if (category, category, category) not in category_list:
									category_list.append((category, category, category))
		
							if "OBJECT" in ob_value:
								object_value_found = True
							if "IMAGE" in ob_value:
								image_value_found = True
						if object_value_found == False:
							list_objects.append("OBJECT: " + name)

						for ob_value in list_objects:
							if "OBJECT" in ob_value and image_value_found == False:
								
								image = ob_value.replace("OBJECT: ", "")
								list_objects.append("IMAGE: " + image + "." + ending)

						if list_objects[0] not in disabled_objects:
							global_object_list.append((global_object_name,global_object_name,global_object_name))
							global_object_values.append(list_objects)
								
							
								
				
			f.close()





test_items = [("all", "all", "all")]
selected_image = "none"

@persistent
def populate_coll(scene):
	bpy.app.handlers.scene_update_pre.remove(populate_coll)
	global selected_image
	test_items.clear()
	test_items.append(("all", "all", "all"))
	scene.sel_category = "all"
	for cat_list_item in category_list:
		if cat_list_item[0] not in hide_list:
			test_items.append(cat_list_item)




@persistent
def refresh_coll(scene):
	bpy.app.handlers.scene_update_pre.remove(refresh_coll)
	global selected_image
	new_list = []
	for xy in scene.coll:

		new_list.append((xy.name, xy.name, xy.name))
	if new_list == global_object_list:
		print ("test")
	else:
		bpy.app.handlers.scene_update_pre.append(populate_coll)



@persistent	
def new_file_handler(scene):
	if not bpy.data.filepath:
		bpy.app.handlers.scene_update_pre.append(populate_coll)
	else:
		bpy.app.handlers.scene_update_pre.append(refresh_coll)
	category_list.clear()
	hide_value_list.clear()
	hide_list.clear()
	disabled_sets.clear()
	add_value_list.clear()

	




def list_populate(self, context):
	global test_items
	return test_items










def dir_path_update(self, context):
	choose_path = context.scene.choose_path

	category_list.clear()
	hide_value_list.clear()
	hide_list.clear()
	disabled_sets.clear()
	add_value_list.clear()
	

	if choose_path:
		test_items.clear()
		test_items.append(("all", "all", "all"))
		context.scene.sel_category = "all"
		for cat_list_item in category_list:
			folder = get_object_value(context.scene.game_object, "FOLDER")[0]
			if cat_list_item[0] not in hide_list:
				test_items.append(cat_list_item)
			
		

def category_choose(self, context):

	if context.scene.sel_category != "all":
		context.scene.game_object = ""
		sorted_objects = []
		for value in global_object_values:
			if ("CATEGORY: "+ context.scene.sel_category) in value:
				sorted_objects.append((value[0], value[0], value[0]))
		context.scene.coll.clear()
		for identifier, name, description in sorted_objects:
			context.scene.coll.add().name = name

	else:
		context.scene.game_object = ""	
		context.scene.coll.clear()
	
		make_list(context.scene.choose_path)
		for identifier, name, description in global_object_list:
			context.scene.coll.add().name = name


def object_choose(self, context):
	global selected_image
	global ui_tex
	if context.scene.game_object != "":
	
		selected_image = get_object_value(context.scene.game_object, "IMAGE")
		if selected_image[0] == "no_value_found":
			selected_image = ["no_image_found.png"]
		folder = get_object_value(context.scene.game_object, "FOLDER")[0]
		file_dir = context.scene.choose_path + folder + "/"
		for image in bpy.data.images:
			if "UI_image" in image.name:
		
				image.user_clear()
				bpy.data.images.remove(image)

		try:
			
			img = bpy.data.images.load(filepath=context.scene.choose_path + folder + "/images/" + selected_image[0])
			img.name = "UI_image"

			tex_found = False
			for tex in bpy.data.textures:
				if tex.name == "UI_image":
					tex_found = True
			if tex_found == False:

				ui_tex = bpy.data.textures.new("UI_image", type = "IMAGE")
				ui_tex.use_fake_user = True
				ui_tex.image = img

			





				

			
		except:
			img = bpy.data.images.load(filepath=os.path.dirname(__file__) + "/no_image.png")
			img.name = "UI_image"

		
			

							
			

		



def get_object_value(ob, value):
	value_Found = False
	valueList = []
	for obs in global_object_values:
		if ob in obs:
			for values in obs:
				if values.find(value)>= 0:
					values = values.replace(value + ": ", "")
					valueList.append(values)
					value_Found = True
	if value_Found == False:
		valueList = ["no_value_found"]
	return valueList


	
